



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Android实现静默安装与卸载</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Android实现静默安装与卸载</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-13 18:24:35 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>一般情况下，<a href="http://lib.csdn.net/base/15" rel="external nofollow noreferrer">Android</a>系统安装apk会出现一个安装界面，用户可以点击确定或者取消来进行apk的安装。</p>
<p>但在实际的项目需求中，有一种需求，就是希望apk在后台安装(不出现安装界面的提示)，这种安装方式称为静默安装。</p>
<p>Android实现静默安装的方式有很多，这里只介绍一种比较简单易理解的方法，就是调用Android未公开的API(installPackage)来实现。</p>
<p>下面通过一种简单的Demo来简单实现静默安装，界面如下：</p>
<p>当点击"静默安装"的按钮时，会在后台安装360手机卫士的apk，安装成功后，会弹出Toast提示安装成功。</p>
<p>首先需要再AndroidManifest.xml声明下面的权限:</p>
<p>&lt;uses-permission android:name="android.permission.INSTALL_PACKAGES" /&gt;</p>
<p>然后主要实现的代码如下：</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20141105163918419?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQvc2hpbmVmbG93ZXJz/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></p>
<p>从上面可以看出，事先需要再SD卡上放一个需要静默安装的apk(没有检测这个apk是否存在，只是简单实现)</p>
<p>上面的方法中涉及到了PackageInstallObserver类，实现代码如下：</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20141105164016888?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQvc2hpbmVmbG93ZXJz/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></p>
<p>代码部分已经基本实现完成，但是在eclipse里面，这个Demo是编译不过的，因为installPackage这个API没有公开，在上层是调用不到的，所以，需要在Android源码的环境下编译，在Demo根目录下新建Android.mk文件，内容如下：</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20141105164151687?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQvc2hpbmVmbG93ZXJz/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/Center" /></p>
<p>Android.mk的写法有固定的格式和写法，如果不会写，可以参考Android源码中个系统应用mk文件的写法。</p>
<p>下面简单介绍下mk几个选项的含义:</p>
<p>下面的头和尾的写法都是固定的：</p>
<p>LOCAL_PATH:= $(call my-dir)<br />include $(CLEAR_VARS)<br />......<br />LOCAL_SRC_FILES := $(call all-subdir-<a href="http://lib.csdn.net/base/17" rel="external nofollow noreferrer">Java</a>-files)<br />......<br />include $(BUILD_PACKAGE)</p>
<div>LOCAL_MODULE_TAGS ：=user eng tests optional</div>
<div>user: 指该模块只在user版本下才编译</div>
<div>eng: 指该模块只在eng版本下才编译</div>
<div>tests: 指该模块只在tests版本下才编译</p>
</div>
<div>optional:指该模块在所有版本下都编译</div>
<div>LOCAL_PACKAGE_NAME &nbsp; 需要编译项目的名称</div>
<div>如果你的APK依赖第三方jar包，还可以通过下面的选项来定义</div>
<div>LOCAL_STATIC_JAVA_LIBRARIES := xsocket jackson-mapper logging jackson-core javatar log4j</div>
<div>Android.mk的洗发和规范有很多，具体可以在网上查查资料。</div>
<div>&nbsp;</div>
<div>准备就绪后，就可以在Android源码环境下通过mmm编译这个Demo了，当然源码的编译环境需要自己配置。</div>
<div>另外，静默卸载也可以通过这种方式实现，与installPackage对应的还有个deletePackage的API，用法跟上面是一样的。</div>
<p>按照上面方法，有的人可能会出现下面的这个错误：</p>
<p>java.lang.SecurityException: Neither user 10034 nor current process has android.permission.INSTALL_PACKAGES.</p>
<p>这是因为只有系统应用才有android.permission.INSTALL_PACKAGES这个权限。出现这个问题的原因是，没有将自己的应用放在Android源码packages/app目录下就直接进行模块编译，这样编译出来的APK不是系统应用，没有系统的权限。解决这个问题有两种方法：</p>
<p>1. 将自己的应用放在packages/app目录下再进行模块编译</p>
<p>2. 直接安装out/target/product/generic/obj/APPS/应用名_intermediates/Package.apk.unaligned这个APK，就不会有这个问题。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/m96mpjn8.html">Windows操作系统待整理</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8k2mz78.html">JS实现div动态水平垂直居中</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9pywjd9.html">配置lamp中的apache</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7wyvk9.html">java学习笔记--IO流</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gl6o4q.html">Twitter search API</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdz7778.html">使用git和github托管个人项目</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rd0jjr8.html">python with语句上下文管理的两种实现方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zlnm49.html">lintcode ：二叉树的最大深度</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdm3rd8.html">Java到底是不是一种纯面向对象语言？</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnorn2q.html">如何将mongodb bson文件转成json文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjomkz8.html">UVALive 2523&Tab;Machine Schedule（二分图求最大匹配数）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z76g09.html">201521123121 《Java程序设计》第3周学习总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jy2ww8.html">js页面事件方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1x6jmq.html">NSLog&lpar; &commat;&amp;quot&semi;&percnt;&commat;&amp;quot&semi;&comma; i &rpar;&semi;</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yeydw8.html">【web&period;xml】项目从web&period;xml开始</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1kr6lq.html">HTTP协议初步解析</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ko01lrq.html">if 和 elif       的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyvxzmxq.html">codeforces 560 C Gerald&amp;amp&semi;&num;39&semi;s Hexagon</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jmr6yg9.html">Linux内核同步 - Per-CPU变量</a>
		</li>
						<li><a href="https://www.batexi.com/a/93jxzr08.html">socket通信循环</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qn12nek8.html">js中关于arguments</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pjkp1y9.html">&lbrack;再寄小读者之数学篇&rsqb;&lpar;2014-12-04 &dollar;&bsol;left&lpar;1&plus;&bsol;frac&lbrace;1&rcub;&lbrace;x&rcub;&bsol;right&rpar;&Hat;x&amp;gt&semi;&bsol;frac&lbrace;2ex&rcub;&lbrace;2x&plus;1&rcub;&comma;&bsol;forall&bsol; x&amp;gt&semi;0&period;&dollar;&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rdy4x48.html">查看linux中swap内存的相关参数</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyd42pdq.html">js String方法集合</a>
			</li>
						<li><a href="https://www.batexi.com/a/95xmmv08.html">windows下ncl生成tiff图（案例）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2wm0plq.html">【LeetCode】14 - Longest Common Prefix</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rdy1z78.html">ASP&period;NET MVC Razor视图引擎攻略</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pjk3m49.html">写在阿里去IOE一周年</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j0nv6eq.html">Hadoop第三天---分布式文件系统HDFS&lpar;大数据存储实战&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z1rewd9.html">CenotOS ip a</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
